#include<stdio.h>
#include <stdlib.h> 
#include <string.h> 
#include <math.h> 

void labelmin_sw(int z, int y, int x, int south, int west);
void labelmin_dw(int z, int y, int x, int down, int west);
void labelmin_ds(int z, int y, int x, int down, int south);
void neighbours_dsw(int z,int y,int x,int down,int south,int west);
void labelmin_dsw(int z, int y, int x, int down, int south, int west);
int intmax(int valuea,int valueb);
int intmin(int valuea,int valueb);
int proper( int label );
int findmin(int a, int b, int c );
void printlabel();
int newcluster(int ncluster, int z, int y, int x);
void initlabel();
void calclabel();
void neighbours_sw(int z, int y, int x, int south, int west);
void neighbours_ds(int z, int y, int x, int south, int west);
void neighbours_dw(int z, int y, int x, int south, int west);

#define nlin 4
#define K 1
#define xi_c 0.3
#define c1 0.33

#define E_0 1



int label,seed,iz=1,mz[250];
double norm,jzmax=2147483647;
int i,j,k,x,y,z,l,summe[nlin*nlin],summe2[nlin*nlin],summe3[nlin*nlin],Hmax,lly,Hmax1,h_k_x,h_k_y,h_k_z,h_kk[nlin*nlin],hhhh,hhhh_x,hhhh_y,hhhh_z,h[nlin*nlin];
int pp;

double rnd1;
double rnd,p1[nlin*nlin],p2[nlin*nlin],p[nlin*nlin];
int summe_hh_k[nlin*nlin],hh,hh_k[1000][1000],hhh[nlin*nlin];
int summe1,summe4[nlin*nlin],h_x[nlin*nlin],h_y[nlin*nlin],ll,lll,J,h_max,hh_max,hhh_max,hhhh_max,summe_c[K],summe_cl; 
int Xmax;
//Global parameter von label
int cl[nlin][nlin][nlin];
double struc[nlin][nlin][nlin],struc3[nlin][nlin][nlin],struc1[nlin][nlin][nlin],struc2[nlin][nlin][nlin],struc4[nlin][nlin][nlin];
//--------------------------------
//Global parameter von hilfreichen Gittern
int struc_help1[nlin][nlin][nlin+1],struc_help2[nlin][nlin+1][nlin],struc_help3[nlin+1][nlin][nlin];
int np[500000];
//--------------------------------
void rndNum(int seed)  //Kirkpatrick Stall Generator1
{
int jz,a0=16807;
norm=1.0/jzmax;
jz=2*seed+1;
for(i=0;i < 250;i++){
jz *= a0;
if(jz < 0)
jz += jzmax +1;
mz[i] = jz;}
}
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
void Struktur()  //Kirkpatrick Stall Generator1
{
for(z = 0;z <=(nlin/2);z++){
for(y = 0;y <=(nlin/2);y++){           
for(x = 0;x <=(nlin/2);x++){
iz = (iz + 1) % 250;
mz[iz] ^= mz[(iz+103) % 250];
rnd = mz[iz]*norm;
rnd1=E_0*rnd;//printf(" rnd1 ist %f\n", rnd1);
struc[2*z][2*y][2*x]=rnd1;//printf("struc[%d][%d][%d] ist %f\n",2*z,2*y,2*x,struc[2*z][2*y][2*x]);
}}}
}
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
void calclabel()
{
  int x,y,z;
  int ncluster = 0; 
  int down=0,west=0,south=0;

for(z = 0;z <=(nlin/2);z++){
for(y = 0;y <=(nlin/2);y++){           
for(x = 0;x <=(nlin/2);x++){
           cl[2*z][2*y][2*x] = 0;
     }}}
z = 0;
if( struc[0][0][0]<0 )
ncluster = newcluster(ncluster,0, 0, 0);


for(x = 1; x <=(nlin/2);x++){
       if( struc[2*z][0][2*x]<0 ){
            west = 2*x - 2;
            if((struc[2*z][0][west]<0)&(struc_help1[2*z+1][1][2*x-1]==1))
               cl[2*z][0][2*x] = cl[2*z][0][west]; 
            else 
               ncluster = newcluster( ncluster,0,  0, x);
       }
  }

  for(y = 1; y <=(nlin/2);y++){
       if(struc[2*z][2*y][0]<0){
          south = 2*y - 2;
          if((struc[2*z][south][0]<0)&(struc_help2[2*z+1][2*y-1][1]==1))
             cl[2*z][2*y][0] = cl[2*z][south][0];
          else
             ncluster = newcluster( ncluster,z,y , 0);
       }
       for(x = 1; x<=(nlin/2);x++){
          if(struc[2*z][2*y][2*x]<0){
             south =2*y - 2;
             west = 2*x - 2;
                           if((struc_help1[2*z+1][2*y+1][2*x-1]==0)&(struc_help2[2*z+1][2*y-1][2*x+1]==0))
                                             ncluster = newcluster(ncluster,0, y, x);

                            if((struc_help1[2*z+1][2*y+1][2*x-1]==1)&(struc_help2[2*z+1][2*y-1][2*x+1]==0))
                                          cl[2*z][2*y][2*x] = cl[2*z][2*y][west];

                                                                                              
                               if((struc_help1[2*z+1][2*y+1][2*x-1]==0)&(struc_help2[2*z+1][2*y-1][2*x+1]==1))

                                 cl[2*z][2*y][2*x] =cl[2*z][south][2*x];


                               if((struc_help1[2*z+1][2*y+1][2*x-1]==1)&(struc_help2[2*z+1][2*y-1][2*x+1]==1))
                                          neighbours_sw(z, y, x, south, west);
          }
       }
  }



  for(z = 1; z <=(nlin/2); z++){
      if(struc[2*z][0][0] < 0){
         down = 2*z - 2;
         if((struc[down][0][0] < 0)&(struc_help3[2*z-1][1][1]==1))
            cl[2*z][0][0] = cl[down][0][0];
         
         else
            ncluster = newcluster(ncluster,z, 0, 0);
         
      }


      for(x = 1; x <=(nlin/2);x++){
          if(struc[2*z][0][2*x] < 0){
             down = 2*z - 2;
             west = 2*x - 2;
                           if((struc_help3[2*z-1][1][2*x+1]==0)&(struc_help1[2*z+1][1][2*x-1]==0))
                                             ncluster = newcluster(ncluster,z, 0, x);

                            if((struc_help3[2*z-1][1][2*x+1]==1)&(struc_help1[2*z+1][1][2*x-1]==0))
                                          cl[2*z][0][2*x] = cl[down][0][2*x];

                                                                                              
                               if((struc_help3[2*z-1][1][2*x+1]==0)&(struc_help1[2*z+1][1][2*x-1]==1))

                                 cl[2*z][0][2*x] =cl[2*z][0][west];


                               if((struc_help3[2*z-1][1][2*x+1]==1)&(struc_help1[2*z+1][1][2*x-1]==1))
                                          neighbours_dw(z, 0, x, down, west);
          }
      }

      for(y = 1;y <=(nlin/2);y++){
         if(struc[2*z][2*y][0] < 0){
             down = 2*z - 2;
             south = 2*y - 2;
                                if((struc_help3[2*z-1][2*y+1][1]==0)&(struc_help2[2*z+1][2*y-1][1]==0))
                                             ncluster = newcluster(ncluster,z, y, 0);

                                if((struc_help3[2*z-1][2*y+1][1]==1)&(struc_help2[2*z+1][2*y-1][1]==0))
                                          cl[2*z][2*y][0] = cl[down][2*y][0];

                                                                                              
                               if((struc_help3[2*z-1][2*y+1][1]==0)&(struc_help2[2*z+1][2*y-1][1]==1))

                                 cl[2*z][2*y][0] =cl[2*z][south][0];


                               if((struc_help3[2*z-1][2*y+1][1]==1)&(struc_help2[2*z+1][2*y-1][1]==1))
                                neighbours_ds(z, y, 0, down, south);
             
         }
         for(x = 1;x <=(nlin/2);x++){
            if(struc[2*z][2*y][2*x] < 0){
               down = 2*z-2;
               south = 2*y-2;
               west = 2*x-2;

if(((struc_help3[2*z-1][2*y+1][2*x+1]==0)&(struc_help2[2*z+1][2*y-1][2*x+1]==0))&(struc_help1[2*z+1][2*y+1][2*x-1]==0))
ncluster = newcluster(ncluster,z,y,x);

else{

if((struc_help3[2*z-1][2*y+1][2*x+1]==1)&(struc_help2[2*z+1][2*y-1][2*x+1]==0)&(struc_help1[2*z+1][2*y+1][2*x-1]==0)){
cl[2*z][2*y][2*x] = cl[down][2*y][2*x];}       


if((struc_help3[2*z-1][2*y+1][2*x+1]==0)&(struc_help2[2*z+1][2*y-1][2*x+1]==1)&(struc_help1[2*z+1][2*y+1][2*x-1]==0)){               
cl[2*z][2*y][2*x] =cl[2*z][south][2*x];}


if(((struc_help3[2*z-1][2*y+1][2*x+1]==0)&(struc_help2[2*z+1][2*y-1][2*x+1]==0))&(struc_help1[2*z+1][2*y+1][2*x-1]==1)){                                  
cl[2*z][2*y][2*x] =cl[2*z][2*y][west];}


if((struc_help3[2*z-1][2*y+1][2*x+1]==0)&(struc_help2[2*z+1][2*y-1][2*x+1]==1)&(struc_help1[2*z+1][2*y+1][2*x-1]==1)){
neighbours_sw(z, y, x, south, west);}


if((struc_help3[2*z-1][2*y+1][2*x+1]==1)&(struc_help2[2*z+1][2*y-1][2*x+1]==0)&(struc_help1[2*z+1][2*y+1][2*x-1]==1)){                                   
neighbours_dw(z, y, x, down, west);}


if(((struc_help3[2*z-1][2*y+1][2*x+1]==1)&(struc_help2[2*z+1][2*y-1][2*x+1]==1))&(struc_help1[2*z+1][2*y+1][2*x-1]==0)){
neighbours_ds(z, y, x, down, south);}


if(((struc_help3[2*z-1][2*y+1][2*x+1]==1)&(struc_help2[2*z+1][2*y-1][2*x+1]==1))&(struc_help1[2*z+1][2*y+1][2*x-1]==1)){                                   
neighbours_dsw(z, y, x, down, south, west);}
}

               
            }
         }
      }
      
  }
}
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
int newcluster(int ncluster, int z, int y, int x)  // fuer neue cluster
{
   ncluster += 1;

   cl[2*z][2*y][2*x] = ncluster;

   np[ncluster-1] = 0;

   return ncluster;
}
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
void neighbours_sw(int z, int y, int x, int south, int west)  // nachbarn sw
{

   if( struc[2*z][2*y][west] * struc[2*z][south][2*x] > 0 ){
         labelmin_sw( z,y, x, south, west);
         return;
   }
   else if( cl[2*z][south][2*x] > 0  ){
       cl[2*z][2*y][2*x] = cl[2*z][south][2*x];
       return;
   }
   else
       cl[2*z][2*y][2*x] = cl[2*z][2*y][west];

}
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
void neighbours_dw(int z, int y, int x, int down, int west) // nachbarn dw
{

   if( struc[down][2*y][2*x] * struc[2*z][2*y][west] > 0 ){
         labelmin_dw( z, y, x, down, west);
         return;
   }
   else if( cl[down][2*y][2*x] > 0  ){
       cl[2*z][2*y][2*x] = cl[down][2*y][2*x];
       return;
   }
   else
       cl[2*z][2*y][2*x] = cl[2*z][2*y][west];

}
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
void neighbours_ds(int z, int y, int x, int down, int south)  // nachbarn ds
{

   if( struc[down][2*y][2*x] * struc[2*z][south][2*x] > 0 ){
         labelmin_ds( z, y, x, down, south);
         return;
   }
   else if( cl[down][2*y][2*x] > 0  ){
       cl[2*z][2*y][2*x]=cl[down][2*y][2*x];
       return;
   }
   else
       cl[2*z][2*y][2*x] = cl[2*z][south][2*x];

}
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
void labelmin_sw(int z, int y, int x, int south, int west) // minimum aus zwei label sw
{
   int label1=0, label2=0;
   int lmax=0 ,lmin=0;


   if( cl[2*z][2*y][west] == cl[2*z][south][2*x] )
       cl[2*z][2*y][2*x] = cl[2*z][2*y][west];
   else
   {
       label1 = cl[2*z][2*y][west];
       label2 = cl[2*z][south][2*x];

       label1 = proper(label1);
       label2 = proper(label2);

       lmax = intmax( label1,label2 );
       lmin = intmin( label1,label2 );

       cl[2*z][2*y][2*x] = lmin;

       if(lmax != lmin)
          np[lmax-1] = lmin;
   }

}
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
void labelmin_dw(int z, int y, int x, int down, int west) // minimum aus zwei label dw
{
   int label1=0, label2=0;
   int lmax=0 ,lmin=0;

   if( cl[down][2*y][2*x] == cl[2*z][2*y][west] )
       cl[2*z][2*y][2*x] = cl[2*z][2*y][west];
   else
   {
       label1 = cl[down][2*y][2*x];
       label2 = cl[2*z][2*y][west];

       label1 = proper(label1);
       label2 = proper(label2);

       lmax = intmax( label1,label2 );
       lmin = intmin( label1,label2 );

       cl[2*z][2*y][2*x] = lmin;

       if(lmax != lmin)
          np[lmax-1] = lmin;
   }

}
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
void labelmin_ds(int z, int y, int x, int down, int south) // minimum aus zwei label ds
{
   int label1=0, label2=0;
   int lmax=0 ,lmin=0;

   if( cl[down][2*y][2*x] == cl[2*z][south][2*x] )
       cl[2*z][2*y][2*x] = cl[2*z][south][2*x];
   else
   {
       label1 = cl[down][2*y][2*x];
       label2 = cl[2*z][south][2*x];

       label1 = proper(label1);
       label2 = proper(label2);

       lmax = intmax( label1,label2 );
       lmin = intmin( label1,label2 );

       cl[2*z][2*y][2*x] = lmin;

       if(lmax != lmin)
          np[lmax-1] = lmin;
   }

}
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
void neighbours_dsw(int z, int y ,int x ,int down ,int south ,int west)  // ermittelt nachbarn dsw
{
   if(struc[down][2*y][2*x] * struc[2*z][south][2*x] * struc[2*z][2*y][west] > 0){
         labelmin_dsw( z, y, x, down, south, west);
         return;
   }
   else if(struc[2*z][2*y][west] * struc[2*z][south][2*x] > 0){
        labelmin_sw(z, y, x, south, west);
         return;
   }
   else if(struc[down][2*y][2*x] * struc[2*z][2*y][west] > 0){
         labelmin_dw(z, y, x, down, west);
         return;
   }
   else if(struc[down][2*y][2*x] * struc[2*z][south][2*x] > 0){
         labelmin_ds(z, y, x, down, south);
         return;
   }
   else if(cl[down][2*y][2*x] > 0){
       cl[2*z][2*y][2*x] = cl[down][2*y][2*x];
       return;
   }
   else if(cl[2*z][south][2*x] > 0 ){
       cl[2*z][2*y][2*x] = cl[2*z][south][2*x];
       return;
   }
   else{
       cl[2*z][2*y][2*x] = cl[2*z][2*y][west];
   }
}
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
void labelmin_dsw(int z, int y, int x, int down, int south, int west) // sucht minimum aus drei label d,s,w
{
   int label1=0, label2=0, label3=0;
   int lmin=0;


   if((cl[down][2*y][2*x] == cl[2*z][south][2*x]) && (cl[down][2*y][2*x] == cl[2*z][2*y][west]) )
       cl[2*z][2*y][2*x] = cl[2*z][south][2*x];
   else
   {
       label1 = cl[down][2*y][2*x];
       label2 = cl[2*z][south][2*x];
       label3 = cl[2*z][2*y][west];

       label1 = proper(label1);
       label2 = proper(label2);
       label3 = proper(label3);

       lmin = findmin(label1, label2, label3);

       cl[2*z][2*y][2*x] = lmin;

       if(label1 != lmin)
          np[label1-1] = lmin;
       if(label2 != lmin)
          np[label2-1] = lmin;
       if(label3 != lmin)
          np[label3-1] = lmin;

   }

}
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
int proper(int label)  // sucht proper label
{

   while( np[label -1] != 0 ){
      label = np[label -1];
  }

  return label;
}
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
int intmax(int valuea,int valueb)
{
    if(valuea < valueb)
       return valueb;
    else 
       return valuea;
}
//------------------------------------------------------
int intmin(int valuea,int valueb)
{
    if(valuea < valueb)
       return valuea;
    else 
       return valueb;
}
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
int findmin(int a, int b, int c )  //findet minimum aus a,b,c
{
   int min;

   if((a <= b && b <= c) || (a <= c && c <= b))
     min = a;
   else if((b <= a && a <= c) || (b <= c && c <= a))
     min = b;
   else 
     min = c;

   return min;

}


//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
int main() //hauptfunktion
{
seed=372067;
rndNum(seed);
for(i=0;i<500000; i++){
np[i]=0;
}
Struktur();
for(z = 0;z <=(nlin/2);z++){
for(y=0;y<=(nlin/2);y++){
for(x=0;x<(nlin/2) ;x++){
struc1[2*z][2*y][2*x]=0.5*(fabs(struc[2*z][2*y][2*x+2]-struc[2*z][2*y][2*x])+fabs(struc[2*z][2*y][2*x+2]-c1*E_0)+fabs(c1*E_0-struc[2*z][2*y][2*x]));
//printf("struc1[%d][%d][%d] ist %f\n",2*z, 2*y,2*x,struc1[2*z][2*y][2*x]); 
}}}
for(z = 0;z <=(nlin/2);z++){
for(y=0;y<(nlin/2);y++){
for(x=0;x<=(nlin/2) ;x++){
struc2[2*z][2*y][2*x]=0.5*(fabs(struc[2*z][2*y+2][2*x]-struc[2*z][2*y][2*x])+fabs(struc[2*z][2*y+2][2*x]-c1*E_0)+fabs(c1*E_0-struc[2*z][2*y][2*x]));
//printf("struc2[%d][%d][%d] ist %f\n",2*z, 2*y,2*x,struc2[2*z][2*y][2*x]); 
}}}
for(z = 0;z<(nlin/2);z++){
for(y=0;y<=(nlin/2);y++){
for(x=0;x<=(nlin/2) ;x++){
struc4[2*z][2*y][2*x]=0.5*(fabs(struc[2*z+2][2*y][2*x]-struc[2*z][2*y][2*x])+fabs(c1*E_0-struc[2*z+2][2*y][2*x])+fabs(c1*E_0-struc[2*z][2*y][2*x]));
//printf("struc4[%d][%d][%d] ist %f\n",2*z, 2*y,2*x,struc4[2*z][2*y][2*x]); 
}}}
//****************************************************************************
for(z = 0;z<=(nlin/2);z++){
for(y=0;y<=(nlin/2);y++){
for(x=0;x<(nlin/2) ;x++){
if(struc1[2*z][2*y][2*x]<xi_c){
struc[2*z][2*y][2*x]=struc[2*z][2*y][2*x+2]=-1.0;
struc_help1[2*z+1][2*y+1][2*x+1]=1;}
printf("struc_help1[%d][%d][%d] ist %d\n",2*z+1, 2*y+1,2*x+1,struc_help1[2*z+1][2*y+1][2*x+1]); 
}}}
for(z = 0;z <=(nlin/2);z++){
for(y=0;y<(nlin/2);y++){
for(x=0;x<=(nlin/2) ;x++){
if(struc2[2*z][2*y][2*x]<xi_c){
struc[2*z][2*y][2*x]=struc[2*z][2*y+2][2*x]=-1.0;
struc_help2[2*z+1][2*y+1][2*x+1]=1;}
printf("struc_help2[%d][%d][%d] ist %d\n",2*z+1, 2*y+1,2*x+1,struc_help2[2*z+1][2*y+1][2*x+1]); 
}}}
for(z = 0;z <(nlin/2);z++){
for(y=0;y<=(nlin/2);y++){
for(x=0;x<=(nlin/2) ;x++){
if(struc4[2*z][2*y][2*x]<xi_c){
struc[2*z][2*y][2*x]=struc[2*z+2][2*y][2*x]=-1.0;
struc_help3[2*z+1][2*y+1][2*x+1]=1;}
printf("struc_help3[%d][%d][%d] ist %d\n",2*z+1, 2*y+1,2*x+1,struc_help3[2*z+1][2*y+1][2*x+1]); 
}}}
//****************************************************************************
for(z = 0;z <=(nlin/2);z++){
for(y=0;y<=(nlin/2);y++){
for(x=0;x<=(nlin/2) ;x++){
if(struc[2*z][2*y][2*x]==-1.0){
struc[2*z][2*y][2*x]=struc[2*z][2*y][2*x];}
else{struc[2*z][2*y][2*x]=0;}
printf("struc[%d][%d][%d] ist %f\n",2*z, 2*y,2*x,struc[2*z][2*y][2*x]);
}}}
//****************************************************************************
calclabel();
for(z = 0;z <=(nlin/2);z++){
for(y = 0;y <=(nlin/2);y++){           
for(x = 0;x <=(nlin/2);x++){
label = cl[2*z][2*y][2*x];
if(label > 0){
label = proper(label);
cl[2*z][2*y][2*x] = label;
}printf("cl[%d][%d][%d] ist: %d\n",2*z,2*y,2*x,cl[2*z][2*y][2*x]);
}}}
/*******************************************************/  
Xmax=1;
for(z = 0;z <=(nlin/2);z++){
for(y = 0;y <=(nlin/2);y++){           
for(x = 0;x <=(nlin/2);x++){
if(cl[2*z][2*y][2*x]>Xmax){Xmax=cl[2*z][2*y][2*x];}}}}
for(l = 1;l <=Xmax ;l++){
h[l]=0;}
for(l = 1;l <=Xmax ;l++){
for(z = 0;z <=(nlin/2);z++){
for(y = 0;y <=(nlin/2);y++){           
for(x = 0;x <=(nlin/2);x++){
if(cl[2*z][2*y][2*x]==l){h[l]= h[l]+1;}}}}}
Hmax=0;
for(l = 1;l <=Xmax ;l++){
if(h[l]>Hmax){Hmax=h[l];}}
Hmax1=0;
for(l = 1;l <=Xmax ;l++){
if((h[l]>Hmax1)&&(h[l]!=Hmax)){Hmax1=h[l];}}
for(i = 1;i <=Xmax ;i++){
if(h[i]==Hmax)
ll=i;}
for(j = 1;j <=Xmax ;j++){
if(h[j]==Hmax1)
lll=j;}
/*******************************************************/  
          hhhh_x=0;
for(z = 0;z <=(nlin/2);z++){
for(y = 0;y <=(nlin/2);y++){           
for(x = 0;x <=(nlin/2);x++){
          if((cl[2*z][0][2*y]==ll)&&(cl[2*z][nlin-1][2*x]==ll)){hhhh_x+=1;}
          }
          }
	  }
          if(hhhh_x!=0){printf("Der Label des unendlichen Clusters der %d-ten Konfiguration  ist links,rechts: %d\n",k,ll);h_k_x+=1;summe_c[k]+=1;}
          else if(hhhh_x==0){printf("Es gibt bei der %d-ten Konfiguration  keinen unendlichen Cluster links,rechts\n",k);}
        hhhh_y=0;
for(z = 0;z <=(nlin/2);z++){
for(y = 0;y <=(nlin/2);y++){           
for(x = 0;x <=(nlin/2);x++){
          if((cl[2*z][2*y][0]==ll)&&(cl[2*z][2*x][nlin-1]==ll)){hhhh_y+=1;}
          }
          }
	  }
	  if(hhhh_y!=0){printf("Der Label des unendlichen Clusters der %d-ten Konfiguration  ist oben,unten: %d\n",k,ll);h_k_y+=1;summe_c[k]+=1;}
	  else if(hhhh_y==0){printf("Es gibt bei der %d-ten Konfiguration  keinen unendlichen Cluster oben,unten\n",k);}
	 hhhh_z=0;
for(z = 0;z <=(nlin/2);z++){
for(y = 0;y <=(nlin/2);y++){           
for(x = 0;x <=(nlin/2);x++){
          if((cl[0][2*y][2*x]==ll)&&(cl[2*y][nlin-1][2*x]==ll)){hhhh_z+=1;}
          }
          }
	  }
	  if(hhhh_z!=0){printf("Der Label des unendlichen Clusters der %d-ten Konfiguration  ist vorne,hinter: %d\n",k,ll);h_k_z+=1;summe_c[k]+=1;}
	  else if(hhhh_z==0){printf("Es gibt bei der %d-ten Konfiguration  keinen unendlichen Cluster vorne,hinter\n",k);}
}
/*******************************************************/  
 

 

return 0;
}
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

