#!/bin/csh
setompi
mpirun -np 1 lmp_openmpi -var name $1 < in.create_system.initial
restart2data restart.$1.initial data.$1.initial

sed -e 's/Pair\ Coeffs//g' < data.$1.initial > a
sed -e 's/1\ 200\ 2.5//g' < a > b
sed -e 's/2\ 200\ 2.5//g' < b > a
sed -e 's/3\ 200\ 2.5//g' < a > b
sed -e 's/4\ 200\ 2.5//g' < b > a
sed -e 's/5\ 200\ 2.5//g' < a > b
sed -e 's/6\ 200\ 2.5//g' < b > a
sed -e 's/7\ 200\ 2.5//g' < a > b
sed -e 's/8\ 200\ 2.5//g' < b > a
sed -e 's/3\ atom\ types/3\ atom\ types\n1\ angle\ types/g' < a > b
rm a
mv b data.$1.initial
mpirun -np 1 lmp_openmpi-s -var name $1 < in.create_system.potential
